/*
Copyright (c) 2007, CARDON DE LICHTBUER Rodolphe
All rights reserved.
 
Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:
 
1. Redistributions of source code must retain the above copyright notice, this list
of conditions and the following disclaimer.
 
2. Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.
 
3. The name of the author or contributors may not be used to endorse or promote
products derived from this software without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
 
 */

package be.cardon.xades;

import be.cardon.dsig.dom.DOMCanonicalizationMethod;
import java.net.URI;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import javax.xml.crypto.MarshalException;
import javax.xml.crypto.dom.DOMCryptoContext;
import org.w3c.dom.Element;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import javax.xml.crypto.dsig.XMLSignatureException;
import java.security.Provider;
import javax.xml.crypto.XMLCryptoContext;

/**DOM-based implementation of {@code OtherTimeStampType}.
 *
 * @author CARDON DE LICHTBUER Rodolphe
 */
public class DOMOtherTimeStamp extends DOMGenericTimeStamp{
    
    /** Creates a new instance of DOMOtherTimeStamp */
    public DOMOtherTimeStamp(
            String localName,
            List<DOMReferenceInfo> refInfos,
            DOMCanonicalizationMethod canonicalizationMethod,
            List<DOMEncapsulatedPKIData> encapsulatedTimeStamps,
            List<DOMAnyType> xmlTimeStamps,
            String id, Document doc,
            DOMCryptoContext context)
            throws IllegalArgumentException, MarshalException{ 
        super(localName,
                null, 
                refInfos, 
                canonicalizationMethod, 
                encapsulatedTimeStamps, 
                xmlTimeStamps,
                id, doc, context);
    }
    /**Unmarshall a XadESTimeStamp.*/
    public DOMOtherTimeStamp(Element elem, DOMCryptoContext context)
        throws MarshalException{
        super(elem, context);
        if(getEncapsulatedTimeStamps().size()>0){
            throw new MarshalException("OtherTimeStamp cannot have " +
                    "EncapsulatedTimeStamp elements");
        }
    }
}


