/*
 * XSDURI.java
 *
 * Created on 14 fvrier 2007, 19:52
 *
 
Copyright (c) 2006, CARDON DE LICHTBUER Rodolphe
All rights reserved.
 
Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:
 
1. Redistributions of source code must retain the above copyright notice, this list
of conditions and the following disclaimer.
 
2. Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.
 
3. The name of the author or contributors may not be used to endorse or promote
products derived from this software without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
 
 */

package be.cardon.xml;

import javax.xml.crypto.MarshalException;
import java.net.URI;
import java.net.URISyntaxException;
/**
 *
 * @author crackapat
 */
public class XSDAnyURI {
    
    
    /**Parse a xsd:anyURI. Return null if the anyURI is empty.*/
    public static URI parseURI(String xmlRepresentation) throws MarshalException{
        try{
            if(xmlRepresentation.length()>0){
                return new URI(xmlRepresentation);
            }
            return null;
        }catch(Exception e){
            throw new MarshalException("Invalid AnyURI.",e);
        }
    }
    
    /**Print an URI in xml representation. If URI is null, it returns an 
     * empty string.*/
    public static String printURI(URI uri) throws MarshalException{
       if(uri==null){
           return new String();
       }
       return uri.toString();
    }
}
