/*
Copyright (c) 2007, CARDON DE LICHTBUER Rodolphe
All rights reserved.
 
Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:
 
1. Redistributions of source code must retain the above copyright notice, this list
of conditions and the following disclaimer.
 
2. Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.
 
3. The name of the author or contributors may not be used to endorse or promote
products derived from this software without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
 
 */

package be.cardon.xml;

import javax.xml.crypto.MarshalException;
import java.util.Date;
import java.util.Calendar;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.GregorianCalendar;

/**The xsd:DataTime definition.
 *
 * @author CARDON DE LICHTBUER Rodolphe
 */
public class XSDDateTime {
    
    public static String printDateTime(XMLGregorianCalendar dateTime) 
    throws MarshalException{
        if(dateTime==null){
            throw new NullPointerException("dateTime may not be null");
        }
        return dateTime.toXMLFormat();
    }
    
    public static String printDateTime(GregorianCalendar dateTime)
    throws MarshalException {
        try{
            if(dateTime==null){
                throw new NullPointerException("signingTime may not be null");
            }
            return printDateTime(DatatypeFactory.newInstance().newXMLGregorianCalendar(dateTime));
        }catch(javax.xml.datatype.DatatypeConfigurationException e){
            throw new MarshalException(e);
        }
    }
    
    public static XMLGregorianCalendar parseDateTime(String xmlRepresentation)throws MarshalException{
        try{
            DatatypeFactory df = DatatypeFactory.newInstance();
            return df.newXMLGregorianCalendar(xmlRepresentation);
            
        }catch(javax.xml.datatype.DatatypeConfigurationException e){
            throw new MarshalException(e);
        }
    }
}
