
package test;

import be.cardon.dsig.dom.DOMDigestMethod;
import be.cardon.dsig.dom.DOMX509IssuerSerial;
import be.cardon.sign.xmldsig.dereferencer.DefaultDereferencer;
import be.cardon.xades.*;
import be.cardon.dsig.*;
import be.cardon.xml.XSDBase64Binary;
import java.security.cert.X509Certificate;
import javax.print.attribute.standard.Sides;
import javax.xml.crypto.MarshalException;
import javax.xml.crypto.dsig.spec.DigestMethodParameterSpec;
import javax.xml.validation.Schema;
import javax.xml.validation.Validator;
import javax.xml.validation.ValidatorHandler;

import org.w3c.dom.*;

import javax.xml.crypto.dsig.*;
import javax.xml.crypto.dsig.keyinfo.*;
import javax.xml.crypto.dsig.dom.DOMSignContext;
import javax.xml.crypto.dsig.spec.C14NMethodParameterSpec;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import be.cardon.xades.DOMSignaturePolicyIdentifier.SignaturePolicyId;

import java.security.*;
import java.security.Provider;

import java.util.GregorianCalendar;
import java.util.*;
import java.net.URI;
import java.io.*;
import be.cardon.xades.DOMCertIDList.CertID;
/**
 *
 * @author crackapat
 */
public class testXades2 {
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try{
            
        //key load
        java.io.File file = new java.io.File("c:\\myjava\\xades\\key.p12");
        char[] pass = "test".toCharArray();
        KeyStore ks = KeyStore.getInstance("PKCS12");
        ks.load( new java.io.FileInputStream(file), pass);
        Key key = ks.getKey("demo", pass);
        java.security.cert.Certificate[] chain2 = ks.getCertificateChain("demo");
        List<X509Certificate> chain = new ArrayList<X509Certificate>();
        for(int i =0;i<chain2.length;i++){
            chain.add((X509Certificate)chain2[i]);
        }
        X509Certificate firstCert = chain.get(0);
        
        //xades provider load
        Provider prov = new XadESProvider();
        XMLSignatureFactory fac = XMLSignatureFactory.getInstance("DOM",prov);
               
        //XML factory load
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        dbf.setNamespaceAware(true);
        DocumentBuilder db = dbf.newDocumentBuilder();
        
        Document doc = db.newDocument();

        //XMLDSIG
        DOMSignContext context = new DOMSignContext(
                key, doc);
        XadESContext.setXadesNS(context,Constants.Xades132SpecNS);
        context.putNamespacePrefix(XMLSignature.XMLNS, "ds");
        //context.putNamespacePrefix(Constants.Xades132SpecNS, "xades");
        
       //list of reference
       List<Reference> refs = new ArrayList<Reference>();
       Reference fileRef = fac.newReference(
                        "key.p12",
                        fac.newDigestMethod(DigestMethod.SHA1, null));
        refs.add(fileRef);
        
         Reference qualifiedPropRef = fac.newReference(
                        "#signedP",
                        fac.newDigestMethod(DigestMethod.SHA1, null));
        refs.add(qualifiedPropRef);
       
       //SignedInfo
            CanonicalizationMethod canon = fac.newCanonicalizationMethod(
                    CanonicalizationMethod.INCLUSIVE,
                    (C14NMethodParameterSpec)null);
            SignedInfo si = fac.newSignedInfo(
                    canon, 
                    fac.newSignatureMethod(SignatureMethod.RSA_SHA1, null),
                    refs);
            
            //KeyInfo including certificates chain and Subject name of the 
            //end certificate that contains the public key for validation
            KeyInfoFactory kif = fac.getKeyInfoFactory();
            List<Object> x509dataContent = new ArrayList<Object>(chain);
            X509Certificate endCertificate = chain.get(0);
            x509dataContent.add(kif.newX509IssuerSerial(
                    endCertificate.getSubjectX500Principal().toString(), 
                    endCertificate.getSerialNumber()));
            X509Data x509data = kif.newX509Data(x509dataContent);
            
            KeyInfo ki = kif.newKeyInfo(Collections.singletonList(x509data));
            String xadesPrefix = null;
            
            DOMQualifyingProperties qualif = new DOMQualifyingProperties(doc, 
                    new URI("#Signature-1"), context);
            qualif.setId("Qualif1");
            
            javax.xml.crypto.dom.DOMStructure qualifStruct = new javax.xml.crypto.dom.DOMStructure(qualif.getQPElem());

            
            
            
            DOMUnsignedProperties unProps = new DOMUnsignedProperties("UnProps",
                    doc, context);
            
            
            DOMUnsignedSignatureProperties usp = unProps.getOrCreateUnsignedSignatureProperties();
            
            
            
            usp.addSignatureTimeStamp(java.util.Collections.singletonList(new DOMInclude(
                    new URI("http://timstampreference"))),
                    null, 
                    java.util.Collections.singletonList(
                       new DOMEncapsulatedPKIData("abc".getBytes(), 
                       new URI(DOMEncapsulatedPKIData.BER_ENCODING_v122_URI), 
                       "timestampBER"))
                    , null, 
                    "timestampID");
            
            
            
            qualif.setUnsignedProperties(unProps);
            
            DOMQualifyingPropertiesReference qpRef = new DOMQualifyingPropertiesReference(
                    new URI("http://qualifRef"),
                    "qualifRef",
                    doc, context);
            javax.xml.crypto.dom.DOMStructure qpRefStruct = new javax.xml.crypto.dom.DOMStructure(qpRef.getElement());
            
            
            List<javax.xml.crypto.dom.DOMStructure> xmlObj = 
                    new ArrayList<javax.xml.crypto.dom.DOMStructure>();
            xmlObj.add(qualifStruct);
            xmlObj.add(qpRefStruct);
            XMLObject object = fac.newXMLObject(
                    xmlObj,  
                    "QualifyingInfos",
                    null, 
                    null);
            
            
             //list of all XMLObjects
            List objects = Collections.singletonList(object);
            
            //Signature
            XMLSignature signature = fac.newXMLSignature(
                    si, //signed info
                    ki, //key info
                    objects,
                    "Signature-1", // Signature ID
                    null // SignatureValue ID
                    );
            
            //Base URI (configuring the dereferencer)
           context.setBaseURI(new File("c:/myjava/xades/").toURI().toString());
            
            //Dereferencer
           
           //signed properties
           
          byte[] digest = DOMAllDataObjectsTimeStamp.getDigest("SHA-1", 
                  context, signature, "#signedP");
           
          DOMAllDataObjectsTimeStamp adoTS = new DOMAllDataObjectsTimeStamp(
                  Collections.singletonList(
                    new DOMEncapsulatedPKIData("abc".getBytes(),null,null)),
                  "dataObjectTS", doc,
                  context);
          
          
           System.out.println("\nDIGEST: "+XSDBase64Binary.encode(digest)+"\n");
           
           GregorianCalendar signingTime = new GregorianCalendar(2007,02,01,10,01, 30);
            CertID certID = new CertID(
                    new DOMDigestAlgAndValue(
                            fac.newDigestMethod(DigestMethod.SHA1, null), 
                            "abc".getBytes()),
                    new DOMX509IssuerSerial(firstCert.getIssuerX500Principal().toString(),
                        firstCert.getSerialNumber()),
                    new URI("http://localhost/mycert.cer"));
            List<CertID> certsIDs = new ArrayList<CertID>();
            certsIDs.add(certID);
            DOMCertIDList certsChain = new DOMCertIDList(certsIDs);
            
            List<DOMSigPolicyQualifier> qualifs = new ArrayList<DOMSigPolicyQualifier>();
            qualifs.add(new DOMSPURI(new URI("http://SPURI")));
            qualifs.add(new DOMSPUserNotice(
                    new DOMSPUserNotice.NoticeReference(
                        "organization",
                         Collections.singletonList(new Integer(2))),
                    "explicit text"));
            DOMSignaturePolicyIdentifier policy = new DOMSignaturePolicyIdentifier(
                    new DOMObjectIdentifier(
                        new URI("http://policy"),
                        DOMObjectIdentifier.OIDAsURI,
                        "my policy description",
                        Collections.singletonList(new URI("http://referencePolicy.txt"))),
                     null,
                     new DOMDigestAlgAndValue(
                        fac.newDigestMethod(DigestMethod.SHA1,null),
                        "sdgfjkhdsgkjhdfkjg".getBytes()),
                    qualifs
                    );
            
            
            DOMSignatureProductionPlace spp = new DOMSignatureProductionPlace(
                "Brussels",
                "Brabant",
                "1850",
                "Belgique");
        
            
            DOMEncapsulatedPKIData certRole = new DOMEncapsulatedPKIData(
                    "rolecertifieeeblebleble".getBytes(),new URI("http://encoding/"), "certRole");
            List<DOMEncapsulatedPKIData> certifiedRoles = 
                    new ArrayList<DOMEncapsulatedPKIData>();
            certifiedRoles.add(certRole);
            DOMSignerRole role = new DOMSignerRole(
                    null,
                    certifiedRoles);
            DOMSignedSignatureProperties ssp = new DOMSignedSignatureProperties(
                    signingTime, 
                    certsChain, 
                    policy,
                    spp,
                    role,
                    "idSSP");
            
            
            DOMSignedDataObjectProperties sdo = new DOMSignedDataObjectProperties(
                    Collections.singletonList(
                        new DOMDataObjectFormat(
                            "description",
                            new DOMObjectIdentifier(
                                new URI("http://www.acrobat.com/oid/pdf"),
                                null,
                                "PDF file",
                                null),
                            "mimeType",
                            new URI("http://encoding"),
                            new URI("#datacibled"))),
                    null,  //data commitment
                    Collections.singletonList(adoTS), 
                    null, 
                    "dso");
            
            DOMSignedProperties sp = new DOMSignedProperties(
                    ssp,sdo, "signedP");
            //qualif.setSignedProperties(sp);
           
           
           //timestamp references
           //...
           
            //add sig to qualif
           qualif.setSignedProperties(sp);
           
            //generated and sign the XMLSignature. The DOM document will contain 
            //the XML Signature if this method returns successfully.
            signature.sign(context);
             
        //output
        TransformerFactory tf = TransformerFactory.newInstance();
            tf.newTransformer().transform(
                    new DOMSource(doc),
                    new StreamResult(System.out));
        
               //output
             tf.newTransformer().transform(
                    new DOMSource(doc),
                    new StreamResult(new FileOutputStream(new File("c://test.xml"))));
        
        //query
        DOMQualifyingProperties q2 = DOMQualifyingProperties.getQualifyingProperties(
                signature, context);
        System.out.println("\n[QualifyingProperty:\n"+q2.toString()+"]\n");
        
        List<DOMQualifyingPropertiesReference> qrefs = 
                DOMQualifyingPropertiesReference.getQualifyingPropertiesReferences(
                    signature, context);
        Iterator it = qrefs.iterator();
        while(it.hasNext()){
            System.out.println("[QualifyingPropertyReference:\n"+it.next()+"]\n");
        }
        
        DOMAllDataObjectsTimeStamp daots = q2.getSignedProperties().getSignedDataObjectProperties().
                getAllDataObjectsTimeStamps().iterator().next();
        byte[] digest2 = daots.getDigest("SHA-1", context, signature, "#signedP");
        System.out.println("\nDIGEST: "+XSDBase64Binary.encode(digest2)+"\n");
           
        }catch(Exception e){
            e.printStackTrace();
            Throwable t=e;
            while(t!=null){
                
                StackTraceElement[] stack = t.getStackTrace();
                for(int i=0;i<stack.length;i++){
                    System.out.println(stack[i].toString());
                }
                System.out.println("\n");
                t = t.getCause();
            }
            
            
        }
        
    }
    
}

